# 标准系统如何修改镜像文件的打包参数

标准系统会构建system.img, userdata.img等镜像文件，本文介绍如何修改这些系统镜像文件的打包参数，包括大小，文件系统格式等。

## 镜像文件打包描述文件说明
   每个系统镜像文件都是由一个image_conf.txt描述文件来描述的，其示例格式如下：

   ```
   # 第一行固定为挂载路径，必选参数顺序要保持一致
   /vendor
   # 第二行固定为镜像制作大小
   268434944
   # 镜像文件系统类型，不可缺少,当前仅支持ext4，f2fs将在后续支持
   --fs_type=ext4
   # 后面跟着可选参数
   ```

  如果要修改某个镜像的打包参数，只需要修改//build/ohos/images/mkimage目录下对应的{镜像名}_image_config.txt文件即可。

## 修改单个平台或产品的系统镜像打包参数
  //build/ohos/images/mkimage目录下的{镜像名}_image_config.txt文件是系统默认的镜像打包参数，修改后会影响所有平台所有产品的镜像默认打包行为。
  如果需要修改单个平台或产品的系统镜像打包参数。只需要在对应平台或产品目录下创建定制的{镜像名}_image_config.txt文件，并安装到${product_output_dir}/imagesconf/目录下即可。
  示例的BUILD.gn脚本如下：

   ```
    ohos_copy("all_image_conf") {
      sources = [
        "system_image_conf.txt",
        "userdata_image_conf.txt",
      ]
      outputs = [ "${product_output_dir}/imagesconf/{{source_file_part}}" ]
    }
   ```
   以上脚本完成了system和userdata镜像文件的打包参数定制。
